<?php
/**
 * Table Definition for task
 */
require_once 'DB/DataObject.php';

class libdb_Task extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'task';                            // table name
    var $id;                              // int(1)  not_null primary_key unique_key multiple_key unsigned
    var $time_type;                       // int(1)  not_null unsigned
    var $bdate;                           // date(10)  not_null
    var $edate;                           // date(10)  not_null
    var $work_time;                       // int(1)  not_null unsigned
    var $idowner;                         // int(1)  not_null unsigned
    var $idworker;                        // int(1)  not_null unsigned
    var $idresponsible;                   // int(1)  not_null unsigned
    var $iddoc_chain;                     // int(1)  not_null unsigned
    var $priority;                        // int(1)  not_null unsigned
    var $status;                          // int(1)  not_null unsigned
    var $flags;                           // int(20)  not_null unsigned
    var $chain_state;                     // int(3)  not_null unsigned

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('libdb_Task',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

	function sequenceKey() { return array(false,false); }
}
