<?php
/**
 * Table Definition for issue
 */
require_once 'DB/DataObject.php';

class libdb_Issue extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'issue';                           // table name
    var $id;                              // int(1)  not_null primary_key unique_key multiple_key unsigned
    var $creation_date;                   // datetime(19)  not_null
    var $modification_date;               // datetime(19)  not_null
    var $idresponsible;                   // int(1)  not_null unsigned
    var $idworker;                        // int(1)  not_null unsigned
    var $priority;                        // int(1)  not_null unsigned
    var $status;                          // int(1)  not_null unsigned
    var $status2;                         // int(1)  not_null unsigned

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('libdb_Issue',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

	function sequenceKey() { return array(false,false); }
}
